import os
import kirbybase
db = kirbybase.KirbyBase()

def get_time_format(languages):
    """Return the formatting string for time, according to language preference"""
    if languages and languages[0].lower().startswith('fr'):
        return '%d/%m/%Y %H:%M'
    else:
        return '%Y-%m-%d %H:%M'
        
class Message:

    def __init__(self,author,title,content,parent=-1,thread=-1,date=None, lastDate=None):
        """parent = messageId of the message to which self is an answer 
        (empty if new thread)"""
        self.parent=parent
        self.thread=thread
        self.author=author
        self.title=title
        self.content=content
        if date is None:
            self.date=time.localtime(time.time())
        else:
            self.date=date
        if lastDate is None:
            self.lastDate=self.date
        else:
            self.lastDate=lastDate
        self.numChildren=0

